'use strict'; // if (typeof window === 'undefined' && typeof require === 'function') {
//   var fetch = require('node-fetch')
// }

function _instanceof(left, right) { if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) { return !!right[Symbol.hasInstance](left); } else { return left instanceof right; } }

function _classCallCheck(instance, Constructor) { if (!_instanceof(instance, Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var ls = {
  get: function get(k) {
    var v = localStorage.getItem(k);

    if (!v) {
      return undefined;
    }

    var t = v.split(':-')[0];
    v = v.split(':-')[1];

    switch (t) {
      case 'string':
        return v;
        break;

      case 'number':
        return parseFloat(v);
        break;

      case 'object':
        return JSON.parse(v);
        break;

      case 'boolean':
        return v === 'false' ? false : true;
        break;

      default:
        return v;
        break;
    }
  },
  set: function set(k, v) {
    var t = _typeof(v);

    if (t === 'object') {
      v = JSON.stringify(v);
    }

    localStorage.setItem(k, t + ':-' + v);
  }
};

var Api =
/*#__PURE__*/
function () {
  function Api() {
    var _this = this;

    _classCallCheck(this, Api);

    _defineProperty(this, "get", function (url, params, option) {
      var eache = _this.eache;
      var headers = _this.headers;

      if (option) {
        eache = option.eache;
        headers = option.headers;
      }

      url = _this.host + url;

      if (params) {
        var paramsArray = []; // 拼接参数

        Object.keys(params).forEach(function (key) {
          return paramsArray.push(key + '=' + params[key]);
        });

        if (url.search(/\?/) === -1) {
          url += '?' + paramsArray.join('&');
        } else {
          url += '&' + paramsArray.join('&');
        }
      } // 检查缓存


      if (eache) {
        var localEache = ls.get("api-get:".concat(JSON.stringify(params)) + url);

        if (localEache) {
          return localEache;
        }
      } // fetch请求


      var myFetch = fetch(url, {
        method: 'GET',
        credentials: 'include',
        headers: { ...headers
        }
      });
      return new Promise(function (resolve, reject) {
        _this.timeOut(myFetch).then(function (response) {
          return response.json();
        }).then(function (res) {
          resolve(res);

          if (eache) {
            ls.set('api:' + url, res);
          }
        }).catch(function (e) {
          reject(e);
        });
      });
    });

    _defineProperty(this, "post", function (url, body, option) {
      var eache = _this.eache;
      var headers = _this.headers;

      if (option) {
        eache = option.eache;
        headers = option.headers;
      }

      url = _this.host + url; // Default options are marked with *
      // 检查缓存

      if (eache) {
        var localEache = ls.get("api-post:".concat(JSON.stringify(params)) + url);

        if (localEache) {
          return localEache;
        }
      }

      var myFetch = fetch(url, {
        body: JSON.stringify(body),
        // must match 'Content-Type' header
        cache: 'no-cache',
        // *default, no-cache, reload, force-cache, only-if-cached
        credentials: 'include',
        // include, same-origin, *omit
        headers: {
          'content-type': 'application/json',
          ...headers
        },
        method: 'POST',
        // *GET, POST, PUT, DELETE, etc. 88019005
        mode: 'cors',
        // no-cors, cors, *same-origin
        redirect: 'follow',
        // manual, *follow, error
        referrer: 'no-referrer' // *client, no-referrer

      });
      return new Promise(function (resolve, reject) {
        _this.timeOut(myFetch).then(function (response) {
          return response.json();
        }).then(function (res) {
          resolve(res);

          if (eache) {
            ls.set('api:' + url, res);
          }
        }).catch(function (e) {
          reject(e);
        });
      });
    });

    _defineProperty(this, "put", function (url, body, option) {
      var eache = _this.eache;
      var headers = _this.headers;

      if (option) {
        eache = option.eache;
        headers = option.headers;
      }

      url = _this.host + url; // Default options are marked with *
      // 检查缓存

      if (eache) {
        var localEache = ls.get("api-put:".concat(JSON.stringify(params)) + url);

        if (localEache) {
          return localEache;
        }
      }

      var myFetch = fetch(url, {
        body: JSON.stringify(body),
        // must match 'Content-Type' header
        cache: 'no-cache',
        // *default, no-cache, reload, force-cache, only-if-cached
        credentials: 'include',
        // include, same-origin, *omit
        headers: {
          'content-type': 'application/json',
          ...headers
        },
        method: 'PUT',
        // *GET, POST, PUT, DELETE, etc. 88019005
        mode: 'cors',
        // no-cors, cors, *same-origin
        redirect: 'follow',
        // manual, *follow, error
        referrer: 'no-referrer' // *client, no-referrer

      });
      return new Promise(function (resolve, reject) {
        _this.timeOut(myFetch).then(function (response) {
          return response.json();
        }).then(function (res) {
          resolve(res);

          if (eache) {
            ls.set('api:' + url, res);
          }
        }).catch(function (e) {
          reject(e);
        });
      });
    });

    _defineProperty(this, "patch", function (url, body, option) {
      var eache = _this.eache;
      var headers = _this.headers;

      if (option) {
        eache = option.eache;
        headers = option.headers;
      }

      url = _this.host + url; // Default options are marked with *
      // 检查缓存

      if (eache) {
        var localEache = ls.get("api-patch:".concat(JSON.stringify(params)) + url);

        if (localEache) {
          return localEache;
        }
      }

      var myFetch = fetch(url, {
        body: JSON.stringify(body),
        // must match 'Content-Type' header
        cache: 'no-cache',
        // *default, no-cache, reload, force-cache, only-if-cached
        credentials: 'include',
        // include, same-origin, *omit
        headers: {
          'content-type': 'application/json',
          ...headers
        },
        method: 'PATCH',
        // *GET, POST, PUT, DELETE, etc. 88019005
        mode: 'cors',
        // no-cors, cors, *same-origin
        redirect: 'follow',
        // manual, *follow, error
        referrer: 'no-referrer' // *client, no-referrer

      });
      return new Promise(function (resolve, reject) {
        _this.timeOut(myFetch).then(function (response) {
          return response.json();
        }).then(function (res) {
          resolve(res);

          if (eache) {
            ls.set('api:' + url, res);
          }
        }).catch(function (e) {
          reject(e);
        });
      });
    });

    _defineProperty(this, "del", function (url, body, option) {
      var eache = _this.eache;
      var headers = _this.headers;

      if (option) {
        eache = option.eache;
        headers = option.headers;
      }

      url = _this.host + url; // Default options are marked with *
      // 检查缓存

      if (eache) {
        var localEache = ls.get("api-delete:".concat(JSON.stringify(params)) + url);

        if (localEache) {
          return localEache;
        }
      }

      var myFetch = fetch(url, {
        body: JSON.stringify(body),
        // must match 'Content-Type' header
        cache: 'no-cache',
        // *default, no-cache, reload, force-cache, only-if-cached
        credentials: 'include',
        // include, same-origin, *omit
        headers: {
          'content-type': 'application/json',
          ...headers
        },
        method: 'DELETE',
        // *GET, POST, PUT, DELETE, etc. 88019005
        mode: 'cors',
        // no-cors, cors, *same-origin
        redirect: 'follow',
        // manual, *follow, error
        referrer: 'no-referrer' // *client, no-referrer

      });
      return new Promise(function (resolve, reject) {
        _this.timeOut(myFetch).then(function (response) {
          return response.json();
        }).then(function (res) {
          resolve(res);

          if (eache) {
            ls.set('api:' + url, res);
          }
        }).catch(function (e) {
          reject(e);
        });
      });
    });

    for (var _len = arguments.length, rest = new Array(_len), _key = 0; _key < _len; _key++) {
      rest[_key] = arguments[_key];
    }

    // rest=[host='http://',eache=false];
    switch (rest.length) {
      case 1:
        this.host = rest[0];
        break;

      case 2:
        if (typeof rest[0] == 'string' && typeof rest[1] == 'boolean') {
          this.host = rest[0];
          this.eache = rest[1];
        } else if (typeof rest[0] == 'string' && _typeof(rest[1]) == 'object') {
          this.host = rest[0];
          this.eache = rest[1].eache;
          this.headers = rest[1].headers;
        }

        break;

      default:
        break;
    }
  }

  _createClass(Api, [{
    key: "timeOut",
    value: function timeOut(requestPromise) {
      var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 10000;
      var timeoutAction = null;
      var timerPromise = new Promise(function (resolve, reject) {
        timeoutAction = function timeoutAction() {
          reject('请求超时');
        };
      });
      setTimeout(function () {
        timeoutAction();
      }, timeout);
      return Promise.race([requestPromise, timerPromise]);
    }
  }]);

  return Api;
}();

module.exports = Api;